/// <reference path="../types.d.ts"/>
import './preload-main'
import util, {MezzFileType, MqttStatus, Util, LiveActionType} from '../common/util'
import gc from './gc'
import Ajax from '../common/ajax'
import error from '../common/error'
import MqttMain from './mqtt'
import * as Gc from '../gc.type'

/**
 * @用途
 * @author 黄敏
 * @创建时间 2022-08-02 15:15
 **/

type ValueOf<T> = T[keyof T]

declare global {
  namespace ff {
    type MezzFileType = ValueOf<typeof MezzFileType>
    type MqttStatus = ValueOf<typeof MqttStatus>
    type LiveActionType = ValueOf<typeof LiveActionType>

    //gc全局
    namespace gc {
      type KeyboardShortcut = Gc.KeyboardShortcut
      type Client = Gc.Client
      type Subscribes = Gc.Subscribes
    }
  }
  var ff: {
    MqttStatus: typeof MqttStatus
    LiveActionType: typeof LiveActionType
    MqttMain:typeof MqttMain
    error: typeof error
    util: Util
    gc: ff.gc.Client
    Ajax: typeof Ajax
  }
}

global.ff = {
  MqttMain,
  MqttStatus,
  LiveActionType,
  error,
  util,
  Ajax,
  gc,
}
