/// <reference path="../types.d.ts"/>
import mqttHandle, {MqttHandle} from './src/mqtt'
import gcHandle, {GcHandle} from './src/gc'
import windowHandle,{WindowHandle} from "./src/window";
import {contextBridge, ipcRenderer} from 'electron'
/**
 * @用途
 * @author 黄敏
 * @创建时间 2022-08-19 08:14
 **/
let _glob = {
  mqtt: mqttHandle,
  gc: gcHandle,
  window:windowHandle,
  getWebContentId: () => ipcRenderer.sendSync('getWebContentId'),
  getCookie: (args: Electron.CookiesGetFilter) => ipcRenderer.invoke('get-cookie', args),
  setCookie: (args: Electron.CookiesSetDetails) => ipcRenderer.invoke('set-cookie', args),
}

contextBridge.exposeInMainWorld('_pre_', _glob)

declare global {
  var _pre_: Readonly<{
    gc: GcHandle
    mqtt: MqttHandle
    window:WindowHandle,
    getWebContentId(): number
    getCookie(data: Electron.CookiesGetFilter): Promise<Electron.Cookie[]>
    setCookie(data: Electron.CookiesSetDetails): Promise<void>
  }>
}

window._pre_ = _glob
