/**
 * @用途
 * @author 黄敏
 * @创建时间 2021-12-19 20:03
 **/

//窗口操作
import {ipcRenderer} from 'electron'

interface closeEvent {
  (): void
}

export interface WindowHandle {
  //窗口失去焦点事件
  onblur(on: () => void): closeEvent

  close(isExit?: boolean,isDestroy?:boolean): void

  //最大化窗口/关闭最大化窗口
  maximize(): void

  //最小化窗口
  minimize(): void

  //隐藏窗口
  hide(): void

  focus(): void
}

const windowHandle: WindowHandle = {
  //窗口失去焦点事件
  onblur: function (cb) {
    ipcRenderer.on('window-blur', cb)

    return function () {
      ipcRenderer.off('unmaximize', cb)
    }
  },
  close: (isExit,isDestroy) => ipcRenderer.send('$window/close', isExit,isDestroy),
  maximize: () => ipcRenderer.send('$window/maximize'),
  minimize: () => ipcRenderer.send('$window/minimize'),
  focus: () => ipcRenderer.send('window-focus'),
  hide: () => ipcRenderer.send('$window/hide')
}

export default windowHandle
