/*
 * 联系方式配置
 *
 * */

type L = {
  [key in f2.info.Type]: f2.info.Config
}

let config: L = {
  email: {
    icon: 'info-email',
    color: 'rgb(62, 133, 246)',
    filter: /[^0-9a-zA-Z\-_@.()]/g,
    regular: /^ *[a-zA-Z0-9_\-.]+@[a-zA-Z0-9_\-]+(\.[a-zA-Z0-9_-]+)+$/,
    target: '_self',
    hrefPrefix: 'mailto:@url@'
  },
  phone: {
    icon: 'info-phone',
    color: 'rgb(246, 128, 44)',
    filter: /\D/g, //过滤正则，过滤掉不正确的格式
    regular: /^[0-9]{7,20}$/,
    target: '_self',
    hrefPrefix: 'javascript:;'
  },
  qq: {
    icon: 'info-qq',
    color: 'rgb(83,176,253)',
    filter: /[^0-9]/g,
    regular: /^\d{5,13}$/,
    hrefPrefix: 'tencent://message/?uin=@url@'
  },
  skype: {
    icon: 'info-skype',
    color: 'rgb(0,175,240)',
    regular: /^[\w._-]{3,}/,
    hrefPrefix: 'skype:@url@?userinfo'
  },
  telegram: {
    icon: 'info-telegram',
    color: 'rgb(0,175,240)',
    regular: /^[\w._-]{3,}/,
    hrefPrefix: 'skype:@url@?userinfo'
  },
  wechat: {
    icon: 'info-wechat',
    color: 'rgb(81,195,50)',
    regular: /^\S{3,}$/,
    hrefPrefix: 'javascript:;'
  },

  icq: {
    icon: 'info-icq',
    color: 'rgb(126,189,0)',
    filter: /[^0-9]/g,
    regular: /^\d{5,13}$/,
    id: /^(\d+)$/i,
    hrefPrefix: 'javascript:;'
  },
  whatsapp: {
    icon: 'info-whatsapp',
    color: 'rgb(58,195,76)',
    filter: void 0,
    regular: /^\+\d{5,15}$/,
    id: /^(\+\d+)$/i,
    hrefPrefix: 'javascript:;'
  },
  line: {
    icon: 'info-line',
    color: 'rgb(1,185,1)',
    filter: /[^0-9]/g,
    regular: /^\d{5,15}$/,
    id: /^(\d+)$/i,
    hrefPrefix: 'javascript:;'
  },
}

let ConfigArr:readonly f2.info.TypeConfig[] =Object.freeze( Object.entries(config).map(v=>{
  return {
    type:v[0] as f2.info.Type,
    ...v[1]
  }
}))

export {ConfigArr}
export default config
